#include "WorkerControl.h"

#include "Logger.h"
#include "ProcessRename.h"
#include "ShmManager.h"
#include "ProcessConfig.h"
#include "GarbageCleanThread.h"
#include "GmsSendThread.h"
#include "TopFhsUpdateThread.h"

#include <stdlib.h>
#include <signal.h>
#include <pthread.h>
#include <errno.h>
#include <string.h>
#include <time.h>


// 공유메모리에 Data Set, Get 을 담당할 객체에 대한 포인터.
// Main.cpp 에 전역변수로 정의 되어 있다.
extern CShmManager * g_pShmManager;

// FHS 의 vmasd 가 Broadcasting 하는 각 FHS 의 상태 정보를 수신받기 위한 UDP Socket....
// Main.cpp 에 전역변수로 정의 되어 있다.
extern int g_sockVmasdRecv;

// FHS csagentd 가 전송하는 시스템 상태 정보 수신을 위한 TCP Socket
// Main.cpp 에 전역변수로 정의 되어 있다.
extern int g_sockSystemRecv;

// FHS csagentd 가 전송하는 서비스 상태 체크 정보 수신을 위한 TCP Socket
// Main.cpp 에 전역변수로 정의 되어 있다.
extern int g_sockCheckRecv;

// fimngd 등과 같은 외부 모듈과 통신을 통해 정보를 전달하기 위한 TCP Socket 생성.
// Main.cpp 에 전역변수로 정의 되어 있다.
extern int g_sockInfoSend;



// 프로세스 종료 전 처리할 종료 관련 각 작업을 일괄로 처리하기 위한 함수.
void ReadyToExitWorkerControl()
{
	// Logger 객체 종료 처리.
	CLogger::Exit();

	return;
}

// Worker Control 프로세스에 대한 대한 종료 처리 수신시.
static void SignalWorkerControlTerminate( int nSignalNumber )
{
	// Signal Number 에 따른 로깅처리.
	if( nSignalNumber == SIGTERM )
	{
		_LOG( LINF, "[Control:%d] Process exit by SIGTERM signal. Good Bye..", getpid() );
	}
	else
	{
		_LOG( LWAR, "[Control:%d] Process exit by abnormal signal[%d], Good Bye..", getpid(), nSignalNumber );
	}

	ReadyToExitWorkerControl();

	// 종료전 잠시 대기
	struct timespec sleep;
	sleep.tv_sec = 0;
	sleep.tv_nsec = 500000000;  // 0.5 sec
	nanosleep( &sleep, NULL );
	
	exit( EXIT_SUCCESS );
}

// Worker::Control Process 의 signal 처리기...
void SetWorkerControlSignalHandler()
{
	sigset_t set;
	struct sigaction act;

	memset( &act, 0x00, sizeof( act ) );
	sigfillset( &set );
	sigprocmask( SIG_SETMASK, &set, NULL );
	sigfillset( &act.sa_mask );

	// 무시 처리 signal
	act.sa_handler = SIG_IGN;
	sigaction( SIGPIPE, &act, NULL );	/* desciptor 오류 발생시 Process가 죽는 것은 방지하기 위하여 설정 */
	sigaction( SIGHUP, &act, NULL );	/* process를 기동시킨 관리자의 로그아웃시, 또는 config reload 등의 처리 signal*/
	sigaction( SIGINT, &act, NULL );	/* ^C 키를 누른 경우 받는 신호 => demon 으로 기동되기 땜시 이 신호 못받음 */
	sigaction( SIGQUIT, &act, NULL );	/* 키보드에 의한  Abort 신호 처리 => ? */

	// Worker 프로세스는 자식 프로세스가 존재하지 않으므로 그냥 무시처리함.
	act.sa_handler = SIG_IGN;
	sigaction( SIGCHLD, &act, NULL );

	/* 각종 에러나 사용자의 종료 신호 처리 */
	act.sa_handler = SignalWorkerControlTerminate;
	sigaction( SIGTERM, &act, NULL );	/* kill -TERM 에 의한 프로세스 종료시 */

	// 나머지 신호는 default 처리.

	sigemptyset( &set );                  /* 신호 처리기 처리 설정 위한 블록 해제 */
	sigprocmask( SIG_SETMASK, &set, NULL );
}




// Worker::Control 프로세스의 Main 역활을 수행하기 위한 함수.
int WorkerControlMain()
{
	// 전역 변수로 설정된 socket 중 해당 worker 에서 사용하지 않는 socket 은 close 처리한다.
	if( g_sockVmasdRecv != -1 )
	{
		close( g_sockVmasdRecv );
		g_sockVmasdRecv = -1;
	}
	if( g_sockSystemRecv != -1 )
	{
		close( g_sockSystemRecv );
		g_sockSystemRecv = -1;
	}
	if( g_sockCheckRecv != -1 )
	{
		close( g_sockCheckRecv );
		g_sockCheckRecv = -1;
	}
	if( g_sockInfoSend != -1 )
	{
		close( g_sockInfoSend );
		g_sockInfoSend = -1;
	}
	

	// Process Rename..
	set_ps_display( PROG_NAME": Control", false );
	
	// Set Signal Handler
	SetWorkerControlSignalHandler();


	// 사용할 객체 초기화 처리

	// 1. 공유메모리 상의 garbage 정보를 정리하기 위한 Thread
	CGarbageCleanThread threadGarbageClean( g_pShmManager );
	if( threadGarbageClean.Start() == false )
	{
		_LOG( LWAR, "[Control:%d] garbage clean thread create failed. => Process Exit", getpid() );

		ReadyToExitWorkerControl();
		return EXIT_FAILURE;	// EXIT_FAILURE 를 반환하여 재생성 처리 방지...
	}	
	
	// 2. GMS 로 RC 정보 전달 처리 Thread
	CGmsSendThread threadGmsSend( g_pShmManager );
	if( threadGmsSend.Start() == false )
	{
		_LOG( LWAR, "[Control:%d] gms send thread create failed. => Process Exit", getpid() );

		ReadyToExitWorkerControl();
		return EXIT_FAILURE;	// EXIT_FAILURE 를 반환하여 재생성 처리 방지...
	}
	

	// 3. RCDB 상에 Top FHS 정보 갱신 처리 Thread.
	CTopFhsUpdateThread threadTopFhsUpdate( g_pShmManager );
	if( threadTopFhsUpdate.Start() == false )
	{
		_LOG( LWAR, "[Control:%d] top fhs rcdb update thread create failed. => Process Exit", getpid() );

		ReadyToExitWorkerControl();
		return EXIT_FAILURE;	// EXIT_FAILURE 를 반환하여 재생성 처리 방지...
	}
	
		
	// 대기
	while( 1 )
	{
		// 할일 없어서.. 시그널 수신까지 대기 한다.
		pause();
	}
	

	// 종료시 정리 작업 수행
	ReadyToExitWorkerControl();
	return EXIT_SUCCESS;
}


